package org.xbib.interlibrary.order;

import org.xbib.interlibrary.action.order.OrderAction;
import org.xbib.interlibrary.action.order.OrderRequest;
import org.xbib.interlibrary.action.order.OrderResponse;
import org.xbib.interlibrary.api.ApplicationModule;
import org.xbib.interlibrary.common.Interlibrary;
import org.xbib.interlibrary.common.InterlibraryModule;
import org.xbib.net.Parameter;
import org.xbib.net.ParameterException;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class OrderModule implements InterlibraryModule {

    private Interlibrary interlibrary;

    public OrderModule() {
    }

    @Override
    public String getName() {
        return "OrderModule";
    }

    @Override
    public List<Class<? extends ApplicationModule>> dependsOn() {
        return null;
    }

    @Override
    public void setInterlibrary(Interlibrary interlibrary) {
        this.interlibrary = interlibrary;
    }

    @Override
    public Interlibrary getInterlibrary() {
        return interlibrary;
    }

    public OrderResponse order(Parameter parameter) throws ParameterException {
        OrderRequest.Builder builder = OrderRequest.builder();
        if (parameter.containsKey(OrderParameters.SERVICE, Parameter.Domain.QUERY)) {
            Collection<Object> services = new ArrayList<>();
            for (Object service : parameter.getAll(OrderParameters.SERVICE, Parameter.Domain.QUERY)) {
                if (!"all".equals(service)) {
                    services.add(service);
                }
            }
            builder.setServices(services);
        }
        return order(builder.build());
    }

    public OrderResponse order(OrderRequest orderRequest) {
        return interlibrary.execute(OrderAction.INSTANCE, orderRequest);
    }

    public OrderResponse transport(Parameter parameter) throws ParameterException {
        OrderRequest.Builder builder = OrderRequest.builder();
        if (parameter.containsKey(OrderParameters.SERVICE, Parameter.Domain.QUERY)) {
            Collection<Object> services = new ArrayList<>();
            for (Object service : parameter.getAll(OrderParameters.SERVICE, Parameter.Domain.QUERY)) {
                if (!"all".equals(service)) {
                    services.add(service);
                }
            }
            builder.setServices(services);
        }
        return order(builder.build());
    }


    public OrderResponse transport(OrderRequest orderRequest) {
        return interlibrary.execute(OrderAction.INSTANCE, orderRequest);
    }

    @Override
    public void run() {
    }

    @Override
    public void close() throws IOException {

    }
}
