package org.xbib.interlibrary.order.soap;

import jakarta.xml.bind.JAXBElement;
import jakarta.xml.bind.annotation.XmlElementDecl;
import jakarta.xml.bind.annotation.XmlRegistry;

import javax.xml.namespace.QName;
import java.util.logging.Level;
import java.util.logging.Logger;

@XmlRegistry
public class CreateOrderObjectFactory {

    private static final Logger logger = Logger.getLogger(CreateOrderObjectFactory.class.getName());

    private static final QName CREATEORDER_QNAME = new QName("https://xbib.org/org::xbib::Medea::SOAP::Server", "createorder");

    public CreateOrderObjectFactory() {
        logger.log(Level.INFO, "objectfactory up");
    }

    @XmlElementDecl(namespace = "https://xbib.org/org::xbib::Medea::SOAP::Server", name = "createorder")
    public JAXBElement<CreateOrder> createOrder(CreateOrder value) {
        logger.log(Level.INFO, "objectfactory creatorder");
        return new JAXBElement<>(CREATEORDER_QNAME, CreateOrder.class, null, value);
    }
}
